﻿using igUploadMVC.Models;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using Infragistics.Web.Mvc;
using System.IO;
using System;

namespace igUploadMVC.Controllers
{
    public class HomeController : Controller
    {
        internal static void igUpload_FinishingUpload(object sender, UploadFinishingEventArgs e)
        {
            string ext = Path.GetExtension(e.FileName);
            string filePath = String.Format("{0}{1}", e.FolderPath, e.FileName);
            string fname = Path.GetFileNameWithoutExtension(e.FileName);

            if (System.IO.File.Exists(filePath))
            {
                RenameFile(e.FileName, filePath, e.FolderPath, fname, ext);
            }
            else
            {
                System.IO.File.Copy(filePath, e.FolderPath + "\\" + fname + "(0)" + ext, true);
            }
        }

        public static int counter = 0;

        public static void RenameFile(string fileName, string filePath, string folderPath, string onlyName, string ext)
        {
            string newFilePath = String.Format("{0}{1}{2}", folderPath, onlyName + "(" + counter + ")", ext);

            if (System.IO.File.Exists(newFilePath))
            {
                counter++;
                RenameFile(fileName, filePath, folderPath, onlyName, ext);
            }
            else
            {
                System.IO.File.Copy(filePath, folderPath + "\\" + onlyName + "(" + counter + ")" + ext, true);

            }
        }

        internal static void igUpload_FileUploading(object sender, FileUploadingEventArgs e)
        {
            var temp = 0;
        }

        internal static void igUpload_FinishedUpload(object sender, UploadFinishedEventArgs e)
        {
        }



        public ActionResult Index()
        {
            var viewModel = new CustomersViewModel
            {
                Customers = GetCustomers(),
                CustomerCountSummaries = GetCustomerCounts()
            };

            return View(viewModel);
        }

        private IEnumerable<CustomerCountSummary> GetCustomerCounts()
        {
            var customers = GetCustomers();
            var active = from c in customers
                         where c.IsActive
                         select c;

            var inActive = from c in customers
                           where (c.IsActive == false)
                           select c;

            return new List<CustomerCountSummary> { 
                new CustomerCountSummary { CategoryLabel = "Active", CustomerCount = active.Count() },
                new CustomerCountSummary { CategoryLabel = "Inactive", CustomerCount = inActive.Count() }
            };
        }

        private IEnumerable<Customer> GetCustomers()
        {
            return new List<Customer>
            {
                new Customer { ID=1, Name="John Smith", IsActive=true },
                new Customer { ID=2, Name="Bob Richards", IsActive=false },
                new Customer { ID=3, Name="Marge Wright", IsActive=false },
                new Customer { ID=4, Name="Dwight Long", IsActive=true },
                new Customer { ID=5, Name="Amy Grant", IsActive=true },
            };
        }
    }
}
